#include "myapp.h"

#ifdef Q_WS_WIN
#include <QDebug>
#include <QFrame>
#include <QMainWindow>
#include <QMenuBar>
#include "Windows.h"

bool MyApp::winEventFilter(MSG *message, long *result)
{
    switch(message->message){

    case WM_ACTIVATEAPP:

        if (QWidget * widget = QWidget::find(message->hwnd)){

            // g[X\
            wchar_t text[64];
            int size = GetWindowText(message->hwnd, text, 64);
            qDebug() << "WM_ACTIVATEAPP\tHWND =" << message->hwnd
                        // widget->windowText()Ǝ|LvVȂꍇ̂Win32APIgp
                     << "\tCaption =" << QString::fromWCharArray(text, size)
                     << "\tActivate =" << static_cast<bool>(message->wParam);

            // j[o[̐Fς
            QMainWindow * mainWindow = qobject_cast<QMainWindow *>(widget);
            if (mainWindow){
                QMenuBar * menuBar = mainWindow->menuBar();
                if (menuBar){
                    QPalette palette = menuBar->palette();

                    // QMenuBar ̐FύX
                    if (message->wParam == 1){ // ANeBuɂȂ
                        if (!savedInactiveButtonText_.isValid()){

                            // {̐FۑĂ
                            savedInactiveButtonText_ =
                                    palette.color(QPalette::Inactive,
                                                  QPalette::ButtonText);

                            // g[X\
                            qDebug() << "Save MenuBar Inactive button text color"
                                     << savedInactiveButtonText_;

                            // pbg̃{^eLXgANeBuF==ANeBuFɂB
                            QColor newColor = palette.color(QPalette::Active,
                                                            QPalette::ButtonText);
                            palette.setColor(QPalette::Inactive,
                                             QPalette::ButtonText,
                                             newColor);
                            menuBar->setPalette(palette);

                            // g[X\
                            qDebug() << "Change MenuBar Inactive button text color"
                                     << newColor;
                        }
                    } else { // ANeBuɂȂ
                        if (savedInactiveButtonText_.isValid()){
                            // ۑĂANeBuFɖ߂B
                            palette.setColor(QPalette::Inactive,
                                             QPalette::ButtonText,
                                             savedInactiveButtonText_);
                            menuBar->setPalette(palette);

                            // g[X\
                            qDebug() << "Restore MenuBar Inactive button text color"
                                     << savedInactiveButtonText_;

                            // Qdh~ɏ
                            savedInactiveButtonText_ = QColor();
                        }
                        // ŌɃANeBuEBhEg[X\
                        qDebug() << "Last ActiveWindow ="
                                 << QApplication::activeWindow();

                        // Qt̎dlŔANeBuɂȂƂ 0 ɂBANeBuɂȂ̏
                        // Qt̕ʂ̃bZ[Wŏꂢ̂ŁÃ\[Xł͉Ă܂B
                        QApplication::setActiveWindow(0);
                    }
                }
            }

            // t[̃ANeBuԂς
            // lPalam WM_NCACTIVATE̕Ƃ͈Ⴄ̂ŁA-1ɂđ܂B
            *result = DefWindowProc(message->hwnd,
                                    WM_NCACTIVATE,
                                    message->wParam,
                                    -1);
            return true;
        }
        break;

    case WM_NCACTIVATE:

        if (QWidget * widget = QWidget::find(message->hwnd)){

            // g[X\
            wchar_t text[64];
            int size = GetWindowText(message->hwnd, text, 64);
            qDebug() << "   WM_NCACTIVATE\tHWND =" << message->hwnd
                        // widget->windowText()Ǝ|LvVȂꍇ̂Win32APIgp
                     << "\tCaption =" << QString::fromWCharArray(text, size)
                     << "\tActivate =" << static_cast<bool>(message->wParam);

            // t[̃ANeBuԂς
            if (widget->isModal()){
                // widget[_EBhEꍇ́AwParam̂܂܂ȂĂ͂܂B
                *result = DefWindowProc(message->hwnd,
                                        WM_NCACTIVATE,
                                        message->wParam,
                                        message->lParam);
            } else {
                // t[ɃANeBuԂ̐Fɕۂ
                *result = DefWindowProc(message->hwnd,
                                        WM_NCACTIVATE,
                                        TRUE,
                                        message->lParam);
            }
            return true;
        }
    }
    return false;
}

#endif //Q_WS_WIN

